/*
 *	nr|X^wUWOOO p[\iEBhEpOtBbNCu[
 *
 *					By WADACHI in moto0717@motokho-net
 *								  pde02650@nifty-serve
 *
 *			91/05/12 VER.0.00	create
 *			91/??/?? VER.1.00	first release
 *
 */
#include	<stdio.h>
#include	<pwindow.h>
#include	<signal.h>
#include	"PwGraph.h"
#include	"PwControl.h"
#include	"PwSignal.h"
#include	"PwToolKit.h"

/* draw dot mask pattern */
unsigned char penmask[MAXPENHEIGHT][MAXPENROW] = {{0x80,0x00},{0xc0,0x00}, \
												  {0xe0,0x00},{0xf0,0x00}, \
												  {0xf8,0x00},{0xfc,0x00}, \
												  {0xfe,0x00},{0xff,0x00}, \
												  {0xff,0x80},{0xff,0xc0}, \
												  {0xff,0xe0},{0xff,0xf0}, \
												  {0xff,0xf8},{0xff,0xfc}, \
												  {0xff,0xfe},{0xff,0xff}};
/* default black pattern */
unsigned char solidblack[MAXPENHEIGHT][MAXPENROW] = {{0xff,0xff},{0xff,0xff}, \
													 {0xff,0xff},{0xff,0xff}, \
													 {0xff,0xff},{0xff,0xff}, \
													 {0xff,0xff},{0xff,0xff}, \
													 {0xff,0xff},{0xff,0xff}, \
													 {0xff,0xff},{0xff,0xff}, \
													 {0xff,0xff},{0xff,0xff}, \
													 {0xff,0xff},{0xff,0xff}};
/* default white pattern */													 
unsigned char solidwhite[MAXPENHEIGHT][MAXPENROW] = {{0x00,0x00},{0x00,0x00}, \
													 {0x00,0x00},{0x00,0x00}, \
													 {0x00,0x00},{0x00,0x00}, \
													 {0x00,0x00},{0x00,0x00}, \
													 {0x00,0x00},{0x00,0x00}, \
													 {0x00,0x00},{0x00,0x00}, \
													 {0x00,0x00},{0x00,0x00}, \
													 {0x00,0x00},{0x00,0x00}};
/* mask pattern for PwClearMapArea PwFillRectangle */
unsigned char lrmask[8] = {0xff,0x7f,0x3f,0x1f,0x0f,0x07,0x03,0x01};
unsigned char rrmask[8] = {0x00,0x80,0xc0,0xe0,0xf0,0xf8,0xfc,0xfe};
/* stack used by PwFillField */
FILLQUE	FillQue[FILLQUESZ];
int				InFQPt,OutFQPt;

/*
 *	function:	create struct PWGMAP which keep bitmap memory and
 *				some graphic attributes.
 *
 *	return:		pointer to PWGMAP.
 *				NULL ... not performed
 */
PWGMAP	*PwCreateMap(width,height)
int		width;			/* input:	width of bitmap */
int		height;			/* input:	height of bitmap */
{
	PWGMAP	*mpt;
	int		row;

	row = PWGETROW(width);

	if ((mpt = (PWGMAP *)calloc(1,sizeof (PWGMAP))) == (PWGMAP *)NULL){
		return ((PWGMAP *)NULL);
	}

	if ((mpt->mapaddress = (unsigned char *)calloc(row*height,sizeof (char))) \
		== (unsigned char *)NULL){
		return ((PWGMAP *)NULL);
	}

	mpt->maprow = row;
	mpt->mapwidth = width;
	mpt->mapheight = height;

	PwSetPenSize(mpt,1,1);
	PwSetPenForm(mpt,solidblack);
	PwSetForeground(mpt,solidblack);
	PwSetBackground(mpt,solidwhite);
	PwSetDrawMode(mpt,DM_COPY);
	PwSetFlushMode(mpt,FLS_NONE);

	return (mpt);
}

/*
 *	function:	resize mapsize
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwResizeMap(mpt,width,height)
PWGMAP	*mpt;			/* pointer to PWGMAP */
int		width;			/* input:	width of bitmap */
int		height;			/* input:	height of bitmap */
{
	int		row;

	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	if (mpt->mapaddress == (unsigned char *)NULL){
		return -1;
	}

	free(mpt->mapaddress);

	row = PWGETROW(width);

	if ((mpt->mapaddress = (unsigned char *)calloc(row*height,sizeof (char))) \
		== (unsigned char *)NULL){
		return -1;
	}

	mpt->maprow = row;
	mpt->mapwidth = width;
	mpt->mapheight = height;

	return 0;
}

/*
 *	function:	set bitmap on personal-window which is shown by path.
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwSetMapWindow(mpt,path,windowleft,windowtop,windowwidth,windowheight)
PWGMAP	*mpt;			/* input:pointer to PWGMAP */
int		path;			/* input:path of personal-window */
int		windowleft;		/* input:left point of bitmap in personal-window */
int		windowtop;		/* input:top point of bitmap in personal-window */
int		windowwidth;	/* input:setting width of bitmap in personal-window */
int		windowheight;	/* input:setting height of bitmap in personal-window */
{
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	
	mpt->path = path;
	mpt->windowleft = windowleft;
	mpt->windowtop = windowtop;
	mpt->windowwidth = windowwidth;
	mpt->windowheight = windowheight;
	return 0;
}

/*
 *	function:	set bitmap on PWIN which is shown by pwin.
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwSetMapWin(mpt,pwin,windowleft,windowtop,windowwidth,windowheight)
PWGMAP	*mpt;			/* input:pointer to PWGMAP */
PWIN	*pwin;			/* input:pointer to PWIN */
int		windowleft;		/* input:left point of bitmap in personal-window */
int		windowtop;		/* input:top point of bitmap in personal-window */
int		windowwidth;	/* input:setting width of bitmap in personal-window */
int		windowheight;	/* input:setting height of bitmap in personal-window */
{
	int		ret;
	
	if (mpt == (PWGMAP *)NULL || pwin == (PWIN *)NULL){
		return -1;
	}

	ret = PwSetMapWindow(mpt,pwin->path,windowleft,windowtop,windowwidth, \
							windowheight);
	return ret;
}

/*
 *	function:	set pensize
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwSetPenSize(mpt,width,height)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		width;		/* input:width of pen */ 
int		height;		/* input:height of pen */
{
	int		_PwSetDrawQuick();
	int		i;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	if (width < 1){
		mpt->penwidth = 1;
	}else if (MAXPENWIDTH < width){
		mpt->penwidth = MAXPENWIDTH;
	}else{
		mpt->penwidth = width;
	}

	if (height < 1){
		mpt->penheight = 1;
	}else if (MAXPENHEIGHT < height){
		mpt->penheight = MAXPENHEIGHT;
	}else{
		mpt->penheight = height;
	}
	
	for (i = 0;i < MAXPENHEIGHT;i++){
		mpt->source[i][0] = penmask[mpt->penwidth-1][0] & mpt->penform[i][0];
		mpt->source[i][1] = penmask[mpt->penwidth-1][1] & mpt->penform[i][1];
	}
	_PwSetDrawQuick(mpt);
	return 0;
}
/*
 *	function:	set drawquick switch when pensize is 1 X 1 and
 *				LSB of penform[0][0] is ON and all foreground[*][*] is 0xff
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		_PwSetDrawQuick(mpt)
PWGMAP	*mpt;	/* input:pointer to PWGMAP */
{
	int		i;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	if (mpt->penwidth == 1 && mpt->penheight == 1 && \
	    (mpt->penform[0][0] & 0x80) != 0){
		mpt->drawquick = DQ_ON;
		for (i = 0;i < MAXPENHEIGHT;i++){
			if (mpt->foreground[i][0] != 0xff || \
				mpt->foreground[i][1] != 0xff){
				mpt->drawquick = DQ_OFF;
			}
		}
	}else{
		mpt->drawquick = DQ_OFF;
	}
	return 0;
}

/*
 *	function:	set penform
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwSetPenForm(mpt,penform)
PWGMAP			*mpt;					/* input:pointer to PWGMAP */
unsigned char	penform[][MAXPENROW];	/* input:pointer to penform */
{
	int		_PwSetDrawQuick();
	int		i;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	for (i = 0;i < MAXPENHEIGHT;i++){
		mpt->penform[i][0] = penform[i][0];
		mpt->penform[i][1] = penform[i][1];
	}

	for (i = 0;i < MAXPENHEIGHT;i++){
		mpt->source[i][0] = penmask[mpt->penwidth-1][0] & mpt->penform[i][0];
		mpt->source[i][1] = penmask[mpt->penwidth-1][1] & mpt->penform[i][1];
	}
	_PwSetDrawQuick(mpt);
	return 0;
}

/*
 *	function:	set foreground pattern
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwSetForeground(mpt,foreground)
PWGMAP			*mpt;						/* input:pointer to PWGMAP */
unsigned char	foreground[][MAXPENROW];	/* input:pointer to foreground pattern */
{
	int		_PwSetDrawQuick();
	int		i;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	for (i = 0;i < MAXPENHEIGHT;i++){
		mpt->foreground[i][0] = foreground[i][0];
		mpt->foreground[i][1] = foreground[i][1];
	}
	_PwSetDrawQuick(mpt);
	return 0;
}

/*
 *	function:	set background pattern
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwSetBackground(mpt,background)
PWGMAP			*mpt;						/* input:pointer to PWGMAP */
unsigned char	background[][MAXPENROW];	/* input:pointer to background pattern */
{
	int				i;
	unsigned char	bk;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	bk = background[0][0];
	mpt->clearquick = CQ_ON;

	for (i = 0;i < MAXPENHEIGHT;i++){
		mpt->background[i][0] = background[i][0];
		mpt->background[i][1] = background[i][1];

		if (bk != background[i][0] || bk != background[i][1]){
			mpt->clearquick = CQ_OFF;
		}
	}
	return 0;
}

/*
 *	function:	set draw mode(DM_NOT,DM_OR,DM_XOR,DM_COPY)
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwSetDrawMode(mpt,drawmode)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		drawmode;	/* input:draw mode */
{
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	mpt->drawmode = drawmode;
	return 0;
}

/*
 *	function:	set mode of flushing bitmap image on personal-window
 *				(FLS_NORMAL,FLS_REVERSE,FLS_NONE)
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwSetFlushMode(mpt,flushmode)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		flushmode;	/* input:flush mode */
{
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	
	mpt->flushmode = flushmode;
	return 0;
}

/*
 *	function:	destroy PWGMAP(free PWGMAP and bitmap memory)
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwDestroyMap(mpt)
PWGMAP	*mpt;	/* input:pointer to PWGMAP */
{
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	if (mpt->mapaddress == (unsigned char *)NULL){
		return -1;
	}
	
	free(mpt->mapaddress);
	free(mpt);
	return 0;
}

/*
 *	function:	draw point on bitmap
 *
 *	return:		0  ... normal
 *				-1 error
 */
int		PwDrawPoint(mpt,x,y)
PWGMAP	*mpt;	/* input:pointer to PWGMAP */
int		x;		/* input:relative x on bitmap */
int		y;		/* input:reletive y on bitmap */
{
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	
	PwDrawP(mpt,x,y);

	if (mpt->flushmode != FLS_NONE){
		PwFlushArea(mpt,x,y,mpt->penwidth,mpt->penheight,mpt->flushmode);
	}
	return 0;
}
/*
 *	̊֐͌݃AZu(PwDrawP.a)Ă܂AQl܂ł
 *
 *	{ɂȂb\[XRgƂĎcĂ܂B
 *
 
int		PwDrawP(mpt,x,y)
PWGMAP	*mpt;
int		x;
int		y;
{
	int		sftr,sftl,i,j,k,l,m,height,px,py,rowck;
	unsigned char	src[MAXPENROW+1],notpsz[MAXPENROW+1];
	unsigned char	*saddr,*addr;

	if ((unsigned int)mpt->mapwidth <= (unsigned int)x){
		return -1;
	}
	if ((unsigned int)mpt->mapheight <= (unsigned int)y){
		return -1;
	}

	height = mpt->mapheight - y;
	if (mpt->penheight < height){
		height = mpt->penheight;
	}
	saddr = (x >> 3) + mpt->maprow * y + mpt->mapaddress;
	sftr = x & 7;
	sftl = 8 - sftr;	
	l = y & 15;
	m = (x >> 3) & 1;

	rowck = x >> 3;
	if (rowck < mpt->maprow - 2){
		j = 2;
	}else if (rowck < mpt->maprow - 1){
		j = 1;
	}else{
		j = 0;
	}
	if ((penmask[mpt->penwidth - 1][1]<<sftl) != 0){
		;
	}else if ((penmask[mpt->penwidth - 1][0]<<sftl) != 0){
		if (1 < j){
			j = 1;
		}
	}else if (0 < j){
		j = 0;
	}
		
	switch (mpt->drawmode){
	case DM_NOT:
		for (i = 0;i < height;i++){
			src[0] = (mpt->source[i][0]>>sftr) & mpt->foreground[l][m];
			m++;
			m &= 1;
			src[1] = ((mpt->source[i][1]>>sftr) | (mpt->source[i][0]<<sftl)) & \
						mpt->foreground[l][m];
			m++;
			m &= 1;
			src[2] = (mpt->source[i][1]<<sftl) & mpt->foreground[l][m];
			l++;
			l &= 15;
			addr = saddr + i * mpt->maprow - 1;
			k = -1;
			switch (j){
			case 2:
				k++;
				addr++;
				*addr = *addr & ~src[k];
			case 1:
				k++;
				addr++;
				*addr = *addr & ~src[k];
			default:
				k++;
				addr++;
				*addr = *addr & ~src[k];
			}
		}
		break;
	case DM_OR:
		for (i = 0;i < height;i++){
			src[0] = (mpt->source[i][0]>>sftr) & mpt->foreground[l][m];
			m++;
			m &= 1;
			src[1] = ((mpt->source[i][1]>>sftr) | (mpt->source[i][0]<<sftl)) & \
						mpt->foreground[l][m];
			m++;
			m &= 1;
			src[2] = (mpt->source[i][1]<<sftl) & mpt->foreground[l][m];
			l++;
			l &= 15;
			addr = saddr + i * mpt->maprow - 1;
			k = -1;
			switch (j){
			case 2:
				k++;
				addr++;
				*addr = *addr | src[k];
			case 1:
				k++;
				addr++;
				*addr = *addr | src[k];
			default:
				k++;
				addr++;
				*addr = *addr | src[k];
			}
		}
		break;
	case DM_XOR:
		for (i = 0;i < height;i++){
			src[0] = (mpt->source[i][0]>>sftr) & mpt->foreground[l][m];
			m++;
			m &= 1;
			src[1] = ((mpt->source[i][1]>>sftr) | (mpt->source[i][0]<<sftl)) & \
						mpt->foreground[l][m];
			m++;
			m &= 1;
			src[2] = (mpt->source[i][1]<<sftl) & mpt->foreground[l][m];
			l++;
			l &= 15;
			addr = saddr + i * mpt->maprow - 1;
			k = -1;
			switch (j){
			case 2:
				k++;
				addr++;
				*addr = *addr ^ src[k];
			case 1:
				k++;
				addr++;
				*addr = *addr ^ src[k];
			default:
				k++;
				addr++;
				*addr = *addr ^ src[k];
			}
		}
		break;
	case DM_COPY:
	default:
		for (i = 0;i < height;i++){
			notpsz[0] = ~(mpt->source[i][0]>>sftr);
			notpsz[1] = ~(mpt->source[i][1]>>sftr|mpt->source[i][0]<<sftl);
			notpsz[2] = ~(mpt->source[i][1]<<sftl);
			src[0] = (mpt->source[i][0]>>sftr) & mpt->foreground[l][m];
			m++;
			m &= 1;
			src[1] = ((mpt->source[i][1]>>sftr) | (mpt->source[i][0]<<sftl)) & \
						mpt->foreground[l][m];
			m++;
			m &= 1;
			src[2] = (mpt->source[i][1]<<sftl) & mpt->foreground[l][m];
			l++;
			l &= 15;
			addr = saddr + i * mpt->maprow - 1;
			k = -1;
			switch (j){
			case 2:
				k++;
				addr++;
				*addr = (*addr & notpsz[k]) | src[k];
			case 1:
				k++;
				addr++;
				*addr = (*addr & notpsz[k]) | src[k];
			default:
				k++;
				addr++;
				*addr = (*addr & notpsz[k]) | src[k];
			}
		}
		break;
	}
	return 0;
}
*/

/*
 *	function:	draw line on bitmap
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwDrawLine(mpt,sx,sy,ex,ey)
PWGMAP	*mpt;	/* input:pointer to PWGMAP */
int		sx;		/* input:relative x of start on bitmap */
int		sy;		/* input:relative y of start on bitmap */
int		ex;		/* input:relative x of end on bitmap */
int		ey;		/* input:relative y of end on bitmap */
{
	int		t;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	PwDrawL(mpt,sx,sy,ex,ey);
		
	if (mpt->flushmode != FLS_NONE){
		if (ex < sx){
			t = sx;
			sx = ex;
			ex = t;
		}
		if (ey < sy){
			t = sy;
			sy = ey;
			ey = t;
		}
		PwFlushArea(mpt,sx,sy,ex - sx + mpt->penwidth,ey - sy + mpt->penheight,\
					mpt->flushmode);
	}
	return 0;
}

/*
 *	function:	draw line on bitmap without flush
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwDrawL(mpt,sx,sy,ex,ey)
PWGMAP	*mpt;	/* input:pointer to PWGMAP */
int		sx;		/* input:relative x of start on bitmap */
int		sy;		/* input:relative y of start on bitmap */
int		ex;		/* input:relative x of end on bitmap */
int		ey;		/* input:relative y of end on bitmap */
{
	int		d,t,ax,ay,f;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	ax = (ex - sx) << 1;
	if (ax < 0){
		ax = ~ax;
		ax++;
	}

	ay = (ey - sy) << 1;
	if (ay < 0){
		ay = ~ay;
		ay++;
	}

	if (ax == 0 && ay == 0){
		PwDrawP(mpt,sx,sy);
	}else if (ax == 0){
		if (ey < sy){
			t = sy;
			sy = ey;
			ey = t;
		}

		PwDrawP(mpt,sx,sy);
		while (sy != ey){
			sy++;
			PwDrawP(mpt,sx,sy);
		}
	}else if (ay == 0){
		if (ex < sx){
			t = sx;
			sx = ex;
			ex = t;
		}

		PwDrawP(mpt,sx,sy);
		while (sx != ex){
			sx++;
			PwDrawP(mpt,sx,sy);
		}
	}else if (ax > ay){
		if (ex < sx){
			t = sx;
			sx = ex;
			ex = t;
			t = sy;
			sy = ey;
			ey = t;
		}
		d = (sy < ey ? 1 : -1);
		f = ax >> 1;
		PwDrawP(mpt,sx,sy);
		while(sx != ex){
			sx++;
			f -= ay;
			if (f <= 0){
				sy += d;
				f += ax;
			}
			PwDrawP(mpt,sx,sy);
		}
	}else{
		if (ey < sy){
			t = sx;
			sx = ex;
			ex = t;
			t = sy;
			sy = ey;
			ey = t;
		}
		d = (sx < ex ? 1 : -1);
		f = ay >> 1;
		PwDrawP(mpt,sx,sy);
		while(sy != ey){
			sy++;
			f -= ax;
			if (f <= 0){
				sx += d;
				f += ay;
			}
			PwDrawP(mpt,sx,sy);
		}
	}
	return 0;
}

/*
 *	function:	clear specified area of bitmap by background pattern
 *
 *	return:		 0 ... normal
 *				-1 ... error
 */
int		PwClearArea(mpt,left,top,width,height)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		left;		/* input:left point of clear area on bitmap */
int		top;		/* input:top point of clear area on bitmap */
int		width;		/* input:width of clear area */
int		height;		/* input:height of clear area */
{
	int		leftrow,rightrow,i,j,left_mod_8,right_mod_8,leftrow_mod_2;
	int		rightrow_mod_2,i_mod_maxpenheight,right,bottom;
	unsigned char	lr[MAXPENHEIGHT],rr[MAXPENHEIGHT],notlrrr,notlr,notrr;
	unsigned char	*pt,*ptsv;
	int		*pti,bki;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	if (left < 0 || mpt->mapwidth < left){
		return -1;
	}

	if (top < 0 || mpt->mapheight < top){
		return -1;
	}

	if (width <= 0){
		return -1;
	}else if (mpt->mapwidth < (left + width)){
		width = mpt->mapwidth - left;
	}

	if (height <= 0){
		return -1;
	}else if (mpt->mapheight < (top + height)){
		height = mpt->mapheight - top;
	}

	switch (mpt->clearquick){
	case CQ_ON:
		if (left == 0 && top == 0 && width == mpt->mapwidth && \
			height == mpt->mapheight){

			bki = mpt->background[0][0];
			bki = bki | bki << 8 | bki << 16 | bki << 24;
			pti = (int *)mpt->mapaddress;
			for (i = mpt->maprow * mpt->mapheight / sizeof (int);0 < i;i--){
				*pti = bki;
				pti++;
			}
			pt = (unsigned char *)pti;
			for (i = (mpt->maprow * mpt->mapheight) & 3;0 < i;i--){
				*pt = mpt->background[0][0];
				pt++;
			}
		}else{
			right = left + width;
			bottom = top + height;
			leftrow = left >> 3;
			rightrow = right >> 3;

			if (leftrow == rightrow){
				left_mod_8 = left & 7;
				right_mod_8 = right & 7;
				leftrow_mod_2 = leftrow & 1;
				

				lr[0] = lrmask[left_mod_8] & rrmask[right_mod_8] & \
						mpt->background[0][0];
				notlrrr = ~(lrmask[left_mod_8] & rrmask[right_mod_8]);

				pt = (unsigned char *)mpt->mapaddress + mpt->maprow * top + leftrow;
	
				for (i = top;i < bottom;i++){
					*pt = *pt & notlrrr | lr[0];
					pt += mpt->maprow;
				}
			}else{			
				left_mod_8 = left & 7;
				right_mod_8 = right & 7;

				lr[0] = lrmask[left_mod_8] & mpt->background[0][0];
				rr[0] = rrmask[right_mod_8] & mpt->background[0][0];
				notlr = ~lrmask[left_mod_8];
				notrr = ~rrmask[right_mod_8];
				pt = ptsv = (unsigned char *)mpt->mapaddress + mpt->maprow * top + \
							leftrow;
				for (i = top;i < bottom;i++){
					for (j = leftrow;j <= rightrow;j++){
						if (j == leftrow){
							*pt = *pt & notlr | lr[0];
						}else if (j == rightrow){
							*pt = *pt & notrr | rr[0];
						}else{
							*pt = mpt->background[0][0];
						}
						pt++;
					}
					pt = ptsv = ptsv + mpt->maprow;
				}
			}
		}
		break;
	case CQ_OFF:
	default:
		right = left + width;
		bottom = top + height;
		leftrow = left >> 3;
		rightrow = (left + width) >> 3;

		if (leftrow == rightrow){
			left_mod_8 = left & 7;
			right_mod_8 = right & 7;
			leftrow_mod_2 = leftrow & 1;
				
			for (i = 0;i < MAXPENHEIGHT;i++){
				lr[i] = lrmask[left_mod_8] & rrmask[right_mod_8] & \
						mpt->background[i][leftrow_mod_2];
			}
			notlrrr = ~(lrmask[left_mod_8] & rrmask[right_mod_8]);

			pt = (unsigned char *)mpt->mapaddress + mpt->maprow * top + leftrow;
	
			for (i = top;i < bottom;i++){
				i_mod_maxpenheight = i & (MAXPENHEIGHT - 1);
				*pt = *pt & notlrrr | lr[i_mod_maxpenheight];
				pt += mpt->maprow;
			}
		}else{			
			left_mod_8 = left & 7;
			right_mod_8 = right & 7;
			leftrow_mod_2 = leftrow & 1;
			rightrow_mod_2 = rightrow & 1;

			for (i = 0;i < MAXPENHEIGHT;i++){
				lr[i] = lrmask[left_mod_8] & mpt->background[i][leftrow_mod_2];
				rr[i] = rrmask[right_mod_8] & mpt->background[i][rightrow_mod_2];
			}
			notlr = ~lrmask[left_mod_8];
			notrr = ~rrmask[right_mod_8];

			pt = ptsv = (unsigned char *)mpt->mapaddress + mpt->maprow * top + leftrow;
			for (i = top;i < bottom;i++){
				i_mod_maxpenheight = i & (MAXPENHEIGHT - 1);
				for (j = leftrow;j <= rightrow;j++){
					if (j == leftrow){
						*pt = *pt & notlr | lr[i_mod_maxpenheight];
					}else if (j == rightrow){
						*pt = *pt & notrr | rr[i_mod_maxpenheight];
					}else{
						*pt = mpt->background[i_mod_maxpenheight][j&1];
					}
					pt++;
				}
				pt = ptsv = ptsv + mpt->maprow;
			}
		}
	}

	if (mpt->flushmode != FLS_NONE){
		PwFlushArea(mpt,left,top,width,height,mpt->flushmode);
	}
	return 0;
}

/*
 *	function:	clear bitmap on personal-window by background pattern
 *
 *	return:		 0 ... normal
 *				-1 ... error
 */
int		PwClearMap(mpt)
PWGMAP	*mpt;	/* input:pointer to PWGMAP */
{
	int		ret;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	ret = PwClearArea(mpt,0,0,mpt->mapwidth,mpt->mapheight);
	return ret;
}

/*
 *	function:	fill bitmap
 *
 *	return:		 0 ... normal
 *				-1 ... error
 */
int		_PwFillMap(mpt,c)
PWGMAP			*mpt;	/* input:pointer to PWGMAP */
unsigned char	c;
{
	int		i;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	for (i = 0; i < (mpt->maprow * mpt->mapheight); i++){
		*(mpt->mapaddress + i) = c;
	}
	return 0;
}

/*
 *	function:	draw rectangle on bitmap
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		PwDrawRectangle(mpt,left,top,width,height)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		left;		/* input:left point of rectangle on bitmap */
int		top;		/* input:top point of rectangle on bitmap */
int		width;		/* input:width of rectangle */
int		height;		/* input:height of rectangle */
{
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	
	PwDrawL(mpt,left      ,top       ,left+width,top       );
	PwDrawL(mpt,left      ,top+height,left+width,top+height);
	PwDrawL(mpt,left      ,top       ,left      ,top+height);
	PwDrawL(mpt,left+width,top       ,left+width,top+height);

	if (mpt->flushmode != FLS_NONE){
		PwFlushArea(mpt,left,top,width+mpt->penwidth,mpt->penheight,
					mpt->flushmode);
		PwFlushArea(mpt,left,top+height,width+mpt->penwidth,mpt->penheight,
					mpt->flushmode);
		PwFlushArea(mpt,left,top,mpt->penwidth,height+mpt->penheight,
					mpt->flushmode);
		PwFlushArea(mpt,left+width,top,mpt->penwidth,height+mpt->penheight,
					mpt->flushmode);
	}
	return 0;
}

/*
 *	function:	fill rectangle on bitmap
 *
 *	return:		 0 ... normal
 *				-1 ... error
 */
int		PwFillRectangle(mpt,left,top,width,height)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		left;		/* input:left point of rectangle on bitmap */
int		top;		/* input:top point of rectangle on bitmap */
int		width;		/* input:width of rectangle */
int		height;		/* input:height of rectangle */
{
	int		leftrow,rightrow,i,j,left_mod_8,right_mod_8,leftrow_mod_2;
	int		rightrow_mod_2,i_mod_maxpenheight,right,bottom;
	unsigned char	lr[MAXPENHEIGHT],rr[MAXPENHEIGHT],notlr,notrr;
	unsigned char	*pt,*ptsv;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	if (left < 0 || mpt->mapwidth < left){
		return -1;
	}

	if (top < 0 || mpt->mapheight < top){
		return -1;
	}

	if (width <= 0){
		return -1;
	}else if (mpt->mapwidth < (left + width)){
		width = mpt->mapwidth - left;
	}

	if (height <= 0){
		return -1;
	}else if (mpt->mapheight < (top + height)){
		height = mpt->mapheight - top;
	}

	right = left + width;
	bottom = top + height;
	leftrow = left >> 3;
	rightrow = right >> 3;

	if (leftrow == rightrow){
		left_mod_8 = left & 7;
		right_mod_8 = right & 7;
		leftrow_mod_2 = leftrow & 1;
			
		for (i = 0;i < MAXPENHEIGHT;i++){
			lr[i] = lrmask[left_mod_8] & rrmask[right_mod_8] & \
					mpt->foreground[i][leftrow_mod_2];
		}
		notlr = ~(lrmask[left_mod_8] & rrmask[right_mod_8]);
		pt = (unsigned char *)mpt->mapaddress + mpt->maprow * top + leftrow;

		for (i = top;i < bottom;i++){
			i_mod_maxpenheight = i & (MAXPENHEIGHT - 1);

			switch (mpt->drawmode){
			case DM_NOT:
				*pt = *pt & ~lr[i_mod_maxpenheight];
				break;
			case DM_OR:
				*pt = *pt | lr[i_mod_maxpenheight];
				break;
			case DM_XOR:
				*pt = *pt ^ lr[i_mod_maxpenheight];
				break;
			case DM_COPY:
			default:
				*pt = *pt & notlr | lr[i_mod_maxpenheight];
				break;
			}
			pt += mpt->maprow;
		}
	}else{			
		left_mod_8 = left & 7;
		right_mod_8 = right & 7;
		leftrow_mod_2 = leftrow & 1;
		rightrow_mod_2 = rightrow & 1;

		for (i = 0;i < MAXPENHEIGHT;i++){
			lr[i] = lrmask[left_mod_8] & mpt->foreground[i][leftrow_mod_2];
			rr[i] = rrmask[right_mod_8] & mpt->foreground[i][rightrow_mod_2];
		}
		notlr = ~lrmask[left_mod_8];
		notrr = ~rrmask[right_mod_8];
		pt = ptsv = (unsigned char *)mpt->mapaddress + mpt->maprow * top + leftrow;

		for (i = top;i < bottom;i++){
			i_mod_maxpenheight = i & (MAXPENHEIGHT - 1);
			for (j = leftrow;j <= rightrow;j++){
				if (j == leftrow){
					switch (mpt->drawmode){
					case DM_NOT:
						*pt = *pt & ~lr[i_mod_maxpenheight];
						break;
					case DM_OR:
						*pt = *pt | lr[i_mod_maxpenheight];
						break;
					case DM_XOR:
						*pt = *pt ^ lr[i_mod_maxpenheight];
						break;
					case DM_COPY:
					default:
						*pt = *pt & notlr | lr[i_mod_maxpenheight];
						break;
					}
				}else if (j == rightrow){
					switch (mpt->drawmode){
					case DM_NOT:
						*pt = *pt & ~rr[i_mod_maxpenheight];
						break;
					case DM_OR:
						*pt = *pt | rr[i_mod_maxpenheight];
						break;
					case DM_XOR:
						*pt = *pt ^ rr[i_mod_maxpenheight];
						break;
					case DM_COPY:
					default:
						*pt = *pt & notrr | rr[i_mod_maxpenheight];
						break;
					}
				}else{
					switch (mpt->drawmode){
					case DM_NOT:
						*pt = *pt & ~mpt->foreground[i_mod_maxpenheight][j&1];
						break;
					case DM_OR:
						*pt = *pt | mpt->foreground[i_mod_maxpenheight][j&1];
						break;
					case DM_XOR:
						*pt = *pt ^ mpt->foreground[i_mod_maxpenheight][j&1];
						break;
					case DM_COPY:
					default:
						*pt = mpt->foreground[i_mod_maxpenheight][j&1];
						break;
					}
				}
				pt++;
			}
			pt = ptsv = ptsv + mpt->maprow;
		}
	}

	if (mpt->flushmode != FLS_NONE){
		PwFlushArea(mpt,left,top,width,height,mpt->flushmode);
	}
	return 0;
}

/* constant for PwDrawArc() */
#define		CNST_360_MUL_64	23040

/* constant for _PwDrawArcP() */
#define		CNST_90_MUL_64	5760
#define		CNST_180_MUL_64	11520

/* constant for _PwFillArcP() */
#define		CNST_270_MUL_64	17280

/*
 *	function:	draw arc inner rectangle on bitmap
 *
 *	return:		0 : 
 *				-1: ُ
 */
int		PwDrawArc(mpt,left,top,width,height,ang1,ang2)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		left;		/* input:left point of rectangle on bitmap */
int		top;		/* input:top point of rectangle on bitmap */
int		width;		/* input:width of rectangle */
int		height;		/* input:height of rectaqngre */
int		ang1;		/* input:start angle from 3 o'clock(0 to 360x64) */
int		ang2;		/* input:end angle from start angle(0 to +-360x64 */
{
	int		_PwDrawArcP();
	int		cx,cy,x,y,rx,ry,a,b,f,rx_rx_2,ry_ry_2,startdeg,enddeg,tmp;

	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	if (width < 2 || height < 2){
		return (-1);
	}

	if (ang1 < 0){
		startdeg = CNST_360_MUL_64 - (-ang1 % CNST_360_MUL_64);
	}else{
		startdeg = ang1 % CNST_360_MUL_64;
	}
	if ((ang1 + ang2) < 0){
		enddeg = CNST_360_MUL_64 - (-(ang1 + ang2) % CNST_360_MUL_64);
	}else{
		enddeg = (ang1 + ang2) % CNST_360_MUL_64;
	}
	if (ang2 < 0){
		tmp = startdeg;
		startdeg = enddeg;
		enddeg = tmp;
	}

 	rx = width >> 1;
	ry = height >> 1;
	rx_rx_2 = (rx * rx) << 1;
	ry_ry_2 = (ry * ry) << 1;
	cx = left + rx;
	cy = top + ry;

	x = 0;
	y = ry;

	a = x * ry_ry_2;
	b = y * rx_rx_2;
	f = b >> 1;

	while (a <= b){
		_PwDrawArcP(mpt,cx,cy,x,y,startdeg,enddeg,ang2);
		x++;
		a += ry_ry_2;
		f -= a;
		if (f <= 0){
			y--;
			b -= rx_rx_2;
			f += b;
		}
	}

	x = rx;
	y = 0;

	a = x * ry_ry_2;
	b = y * rx_rx_2;
	f = a >> 1;

	while (b < a){
		_PwDrawArcP(mpt,cx,cy,x,y,startdeg,enddeg,ang2);
		y++;
		b += rx_rx_2;
		f -= b;
		if (f <= 0){
			x--;
			a -= ry_ry_2;
			f += a;
		}
	}
	if (mpt->flushmode != FLS_NONE){
		PwFlushArea(mpt,left,top,width + mpt->penwidth,height + mpt->penheight,\
				 mpt->flushmode);
	}
	return 0;
}

/*
 *	function:	sub function of PwDrawArc
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		_PwDrawArcP(mpt,cx,cy,x,y,startdeg,enddeg,ang2)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		cx;			/* input:point x of center */
int		cy;			/* input:point y of center */
int		x;			/* input:point x of drawing */
int		y;			/* input:point y of drawing */
int		startdeg;	/* input:start angle(absolute) */
int		enddeg;		/* input:end angle(absolute) */
int		ang2;		/* input:end angle from start angle */
{
	int		dg1,dg2,dg3,dg4;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	
/*	߂Ⴀ΂ II	*/
	dg1 = y * CNST_90_MUL_64 / (x + y);
	dg2 = CNST_90_MUL_64 + x * CNST_90_MUL_64 / (x + y);
	dg3 = CNST_180_MUL_64 + dg1;
	dg4 = CNST_180_MUL_64 + dg2;
/*							*/
	if (startdeg < enddeg || ang2 == 0){
		if (startdeg <= dg1 && dg1 <= enddeg){
			PwDrawP(mpt,cx + x,cy + y);
		}
		if (startdeg <= dg2 && dg2 <= enddeg){
			if (x != 0 && y != 0){
				PwDrawP(mpt,cx - x,cy + y);
			}
		}
		if (startdeg <= dg3 && dg3 <= enddeg){
			PwDrawP(mpt,cx - x,cy - y);
		}
		if (startdeg <= dg4 && dg4 <= enddeg){
			if (x != 0 && y != 0){
				PwDrawP(mpt,cx + x,cy - y);
			}
		}
	}else{
		if (startdeg <= dg1 || dg1 <= enddeg){
			PwDrawP(mpt,cx + x,cy + y);
		}
		if (startdeg <= dg2 || dg2 <= enddeg){
			if (x != 0 && y != 0){
				PwDrawP(mpt,cx - x,cy + y);
			}
		}
		if (startdeg <= dg3 || dg3 <= enddeg){
			PwDrawP(mpt,cx - x,cy - y);
		}
		if (startdeg <= dg4 || dg4 <= enddeg){
			if (x != 0 && y != 0){
				PwDrawP(mpt,cx + x,cy - y);
			}
		}
	}
	return 0;
}

/*
 *	function:	fill arc inner rectangle on bitmap
 *
 *	return:		0 : 
 *				-1: ُ
 */
int		PwFillArc(mpt,left,top,width,height,ang1,ang2)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		left;		/* input:left point of rectangle on bitmap */
int		top;		/* input:top point of rectangle on bitmap */
int		width;		/* input:width of rectangle */
int		height;		/* input:height of rectaqngre */
int		ang1;		/* input:start angle from 3 o'clock(0 to 360x64) */
int		ang2;		/* input:end angle from start angle(0 to +-360x64 */
{
	int		_PwCopyPwgmap();
	int		_PwFillArcP();
	int		cx,cy,x,y,rx,ry,a,b,f,rx_rx_2,ry_ry_2,startdeg,enddeg,tmp;
	PWGMAP	pwgmap_save;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	
	if (width < 2 || height < 2){
		return (-1);
	}

	_PwCopyPwgmap(mpt,&pwgmap_save);

	PwSetPenSize(mpt,1,1);
	PwSetPenForm(mpt,solidblack);
	
	if (ang1 < 0){
		startdeg = CNST_360_MUL_64 - (-ang1 % CNST_360_MUL_64);
	}else{
		startdeg = ang1 % CNST_360_MUL_64;
	}
	if ((ang1 + ang2) < 0){
		enddeg = CNST_360_MUL_64 - (-(ang1 + ang2) % CNST_360_MUL_64);
	}else{
		enddeg = (ang1 + ang2) % CNST_360_MUL_64;
	}
	if (ang2 < 0){
		tmp = startdeg;
		startdeg = enddeg;
		enddeg = tmp;
	}

 	rx = width >> 1;
	ry = height >> 1;
	rx_rx_2 = (rx * rx) << 1;
	ry_ry_2 = (ry * ry) << 1;
	cx = left + rx;
	cy = top + ry;

	x = 0;
	y = ry;

	a = x * ry_ry_2;
	b = y * rx_rx_2;
	f = b >> 1;

	while (a <= b){
		x++;
		a += ry_ry_2;
		f -= a;
		if (f <= 0){
			_PwFillArcP(mpt,cx,cy,x,y,startdeg,enddeg,ang2);
			y--;
			b -= rx_rx_2;
			f += b;
		}
	}

	x = rx;
	y = 0;

	a = x * ry_ry_2;
	b = y * rx_rx_2;
	f = a >> 1;

	while (b < a){
		_PwFillArcP(mpt,cx,cy,x,y,startdeg,enddeg,ang2);
		y++;
		b += rx_rx_2;
		f -= b;
		if (f <= 0){
			x--;
			a -= ry_ry_2;
			f += a;
		}
	}
	if (mpt->flushmode != FLS_NONE){
		PwFlushArea(mpt,left,top,width + mpt->penwidth,height + mpt->penheight,\
				 mpt->flushmode);
	}
	_PwCopyPwgmap(&pwgmap_save,mpt);
	return 0;
}

/*
 *	function:	sub function of PwFillArc
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		_PwFillArcP(mpt,cx,cy,x,y,startdeg,enddeg,ang2)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		cx;			/* input:point x of center */
int		cy;			/* input:point y of center */
int		x;			/* input:point x of drawing */
int		y;			/* input:point y of drawing */
int		startdeg;	/* input:start angle(absolute) */
int		enddeg;		/* input:end angle(absolute) */
int		ang2;		/* input:end angle from start angle */
{
	int		dg,wx,wy;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	wy = -y;

	for (wx = -x;wx <= x;wx++){	
	/*	߂Ⴀ΂ II	*/
		if (wx == 0 && y == 0){
			dg = startdeg;
		}else if (0 <= wx){
			dg = y * CNST_90_MUL_64 / (wx + y);
		}else{	/*  if (wx <= 0) */
			dg = CNST_90_MUL_64 - wx * CNST_90_MUL_64 / (-wx + y);
		}
	/*	                        */
		if (startdeg < enddeg || ang2 == 0){
			if (startdeg <= dg && dg <= enddeg){
				PwDrawP(mpt,cx + wx,cy + y);
			}
		}else{
			if (startdeg <= dg || dg <= enddeg){
				PwDrawP(mpt,cx + wx,cy + y);
			}
		}
	/*	߂Ⴀ΂ II	*/
		if (wy != 0){
			if (wx == 0 && wy == 0){
				dg = startdeg;
			}else if (wx <= 0){
				dg = CNST_180_MUL_64 - wy * CNST_90_MUL_64 / (-wx - wy);
			}else if (0 <= wx){
				dg = CNST_270_MUL_64 + wx * CNST_90_MUL_64 / (wx - wy);
			}
		/*	                        */
			if (startdeg < enddeg || ang2 == 0){
				if (startdeg <= dg && dg <= enddeg){
					PwDrawP(mpt,cx + wx,cy + wy);
				}
			}else{
				if (startdeg <= dg || dg <= enddeg){
					PwDrawP(mpt,cx + wx,cy + wy);
				}
			}
		}
	}
	return 0;
}

/*
 *	function:	draw wedge inner rectangle on bitmap
 *
 *	return:		0 : 
 *				-1: ُ
 */
int		PwDrawWedge(mpt,left,top,width,height,ang1,ang2)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		left;		/* input:left point of rectangle on bitmap */
int		top;		/* input:top point of rectangle on bitmap */
int		width;		/* input:width of rectangle */
int		height;		/* input:height of rectaqngre */
int		ang1;		/* input:start angle from 3 o'clock(0 to 360x64) */
int		ang2;		/* input:end angle from start angle(0 to +-360x64 */
{
	int		_PwDrawWedgeP();
	int		cx,cy,x,y,rx,ry,a,b,f,rx_rx_2,ry_ry_2,startdeg,enddeg,tmp;
	int		minstart=CNST_180_MUL_64,minsx,minsy,minend=CNST_180_MUL_64, \
			minex,miney;
			
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	if (width < 2 || height < 2){
		return (-1);
	}

	if (ang1 < 0){
		startdeg = CNST_360_MUL_64 - (-ang1 % CNST_360_MUL_64);
	}else{
		startdeg = ang1 % CNST_360_MUL_64;
	}
	if ((ang1 + ang2) < 0){
		enddeg = CNST_360_MUL_64 - (-(ang1 + ang2) % CNST_360_MUL_64);
	}else{
		enddeg = (ang1 + ang2) % CNST_360_MUL_64;
	}
	if (ang2 < 0){
		tmp = startdeg;
		startdeg = enddeg;
		enddeg = tmp;
	}

 	rx = width >> 1;
	ry = height >> 1;
	rx_rx_2 = (rx * rx) << 1;
	ry_ry_2 = (ry * ry) << 1;
	cx = left + rx;
	cy = top + ry;

	x = 0;
	y = ry;

	a = x * ry_ry_2;
	b = y * rx_rx_2;
	f = b >> 1;

	while (a <= b){
		_PwDrawWedgeP(mpt,cx,cy,x,y,startdeg,enddeg,ang2,&minstart,&minsx,\
					  &minsy,&minend,&minex,&miney);
		x++;
		a += ry_ry_2;
		f -= a;
		if (f <= 0){
			y--;
			b -= rx_rx_2;
			f += b;
		}
	}

	x = rx;
	y = 0;

	a = x * ry_ry_2;
	b = y * rx_rx_2;
	f = a >> 1;

	while (b < a){
		_PwDrawWedgeP(mpt,cx,cy,x,y,startdeg,enddeg,ang2,&minstart,&minsx, \
					  &minsy,&minend,&minex,&miney);
		y++;
		b += rx_rx_2;
		f -= b;
		if (f <= 0){
			x--;
			a -= ry_ry_2;
			f += a;
		}
	}

	PwDrawL(mpt,cx,cy,cx + minsx,cy + minsy);
	if ((ang2 % CNST_360_MUL_64) != 0){
		PwDrawL(mpt,cx,cy,cx + minex,cy + miney);
	}

	if (mpt->flushmode != FLS_NONE){
		PwFlushArea(mpt,left,top,width + mpt->penwidth,height + mpt->penheight,\
				 mpt->flushmode);
	}
	return 0;
}

/*
 *	function:	sub function of PwDrawWedge
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		_PwDrawWedgeP(mpt,cx,cy,x,y,startdeg,enddeg,ang2,minstart,minsx,minsy,\
					  minend,minex,miney)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		cx;			/* input:point x of center */
int		cy;			/* input:point y of center */
int		x;			/* input:point x of drawing */
int		y;			/* input:point y of drawing */
int		startdeg;	/* input:start angle(absolute) */
int		enddeg;		/* input:end angle(absolute) */
int		ang2;		/* input:end angle from start angle */
int		*minstart;	/* i-o	: */
int		*minsx;		/* i-o	: */
int		*minsy;		/* i-o	: */
int		*minend;	/* i-o	: */
int		*minex;		/* i-o	: */
int		*miney;		/* i-o	: */
{
	int		dg1,dg2,dg3,dg4;
	
	if (mpt == (PWGMAP *)NULL || \
		minstart == (int *)NULL || \
		minsx == (int *)NULL || \
		minsy == (int *)NULL || \
		minend == (int *)NULL || \
		minex == (int *)NULL || \
		miney == (int *)NULL){
		return -1;
	}
		
/*	߂Ⴀ΂ II	*/
	dg1 = y * CNST_90_MUL_64 / (x + y);
	dg2 = CNST_90_MUL_64 + x * CNST_90_MUL_64 / (x + y);
	dg3 = CNST_180_MUL_64 + dg1;
	dg4 = CNST_180_MUL_64 + dg2;
/*							*/
	if (startdeg < enddeg || ang2 == 0){
		if (startdeg <= dg1 && dg1 <= enddeg){
			PwDrawP(mpt,cx + x,cy + y);
			if ((dg1 - startdeg) < *minstart){
				*minstart = dg1 - startdeg;
				*minsx = x;
				*minsy = y;
			}
			if ((enddeg - dg1) < *minend){
				*minend = enddeg - dg1;
				*minex = x;
				*miney = y;
			}
		}
		if (startdeg <= dg2 && dg2 <= enddeg){
			if (x != 0 && y != 0){
				PwDrawP(mpt,cx - x,cy + y);
			}
			if ((dg2 - startdeg) < *minstart){
				*minstart = dg2 - startdeg;
				*minsx = -x;
				*minsy = y;
			}
			if ((enddeg - dg2) < *minend){
				*minend = enddeg - dg2;
				*minex = -x;
				*miney = y;
			}
		}
		if (startdeg <= dg3 && dg3 <= enddeg){
			PwDrawP(mpt,cx - x,cy - y);
			if ((dg3 - startdeg) < *minstart){
				*minstart = dg3 - startdeg;
				*minsx = -x;
				*minsy = -y;
			}
			if ((enddeg - dg3) < *minend){
				*minend = enddeg - dg3;
				*minex = -x;
				*miney = -y;
			}
		}
		if (startdeg <= dg4 && dg4 <= enddeg){
			if (x != 0 && y != 0){
				PwDrawP(mpt,cx + x,cy - y);
			}
			if ((dg4 - startdeg) < *minstart){
				*minstart = dg4 - startdeg;
				*minsx = x;
				*minsy = -y;
			}
			if ((enddeg - dg4) < *minend){
				*minend = enddeg - dg4;
				*minex = x;
				*miney = -y;
			}
		}
	}else{
		if (startdeg <= dg1 || dg1 <= enddeg){
			PwDrawP(mpt,cx + x,cy + y);
			if ((dg1 - startdeg) < *minstart && startdeg <= dg1){
				*minstart = dg1 - startdeg;
				*minsx = x;
				*minsy = y;
			}
			if ((enddeg - dg1) < *minend && dg1 <= enddeg){
				*minend = enddeg - dg1;
				*minex = x;
				*miney = y;
			}
		}
		if (startdeg <= dg2 || dg2 <= enddeg){
			if (x != 0 && y != 0){
				PwDrawP(mpt,cx - x,cy + y);
			}
			if ((dg2 - startdeg) < *minstart && startdeg <= dg2){
				*minstart = dg2 - startdeg;
				*minsx = -x;
				*minsy = y;
			}
			if ((enddeg - dg2) < *minend && dg2 <= enddeg){
				*minend = enddeg - dg2;
				*minex = -x;
				*miney = y;
			}
		}
		if (startdeg <= dg3 || dg3 <= enddeg){
			PwDrawP(mpt,cx - x,cy - y);
			if ((dg3 - startdeg) < *minstart && startdeg <= dg3){
				*minstart = dg3 - startdeg;
				*minsx = -x;
				*minsy = -y;
			}
			if ((enddeg - dg3) < *minend && dg3 <= enddeg){
				*minend = enddeg - dg3;
				*minex = -x;
				*miney = -y;
			}
		}
		if (startdeg <= dg4 || dg4 <= enddeg){
			if (x != 0 && y != 0){
				PwDrawP(mpt,cx + x,cy - y);
			}
			if ((dg4 - startdeg) < *minstart && startdeg <= dg4){
				*minstart = dg4 - startdeg;
				*minsx = x;
				*minsy = -y;
			}
			if ((enddeg - dg4) < *minend && dg4 <= enddeg){
				*minend = enddeg - dg4;
				*minex = x;
				*miney = -y;
			}
		}
	}
	return 0;
}

/*
 *	@  \FV[htB@ɂhׂB
 *
 *	return:		 0 ... 
 *				-1 ... ُ
 *
 */
int		PwFillField(mpt,x,y)
PWGMAP	*mpt;
int		x;
int		y;
{
	int		i,j,seedcolor,color,dir_flag,left,right,qy,seed_sw,wleft,wright,\
			b_sw,w_sw;
	PWGMAP	savemap;
	int		_PwPushFQ(),_PwPopFQ(),_PwDrawOver(),_PwCopyPwgmap();
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	
	_PwCopyPwgmap(mpt,&savemap);
	PwSetPenSize(mpt,1,1);
	PwSetPenForm(mpt,solidblack);

	b_sw = ON;
	for (i = 0;i < MAXPENHEIGHT;i++){
		if (savemap.foreground[i][0] != 0xff || \
			savemap.foreground[i][1] != 0xff){
			b_sw = OFF;
		}
	}
	w_sw = ON;
	for (i = 0;i < MAXPENHEIGHT;i++){
		if (savemap.foreground[i][0] != 0x00 || \
			savemap.foreground[i][1] != 0x00){
			w_sw = OFF;
		}
	}
	seedcolor = PwGetPoint(mpt,x,y);
	if ((savemap.drawmode == DM_COPY && seedcolor == 0 && w_sw == ON) || \
		(savemap.drawmode == DM_COPY && seedcolor == 1 && b_sw == ON)){
		_PwCopyPwgmap(&savemap,mpt);
		return 0;
	}
	if ((savemap.drawmode == DM_OR && seedcolor == 0 && w_sw == ON) || \
		(savemap.drawmode == DM_OR && seedcolor == 1)){
		_PwCopyPwgmap(&savemap,mpt);
		return 0;
	}
	if (savemap.drawmode == DM_XOR && w_sw == ON){
		_PwCopyPwgmap(&savemap,mpt);
		return 0;
	}
	if ((savemap.drawmode == DM_NOT && seedcolor == 0) || \
		(savemap.drawmode == DM_NOT && seedcolor == 1 && w_sw == ON)){
		_PwCopyPwgmap(&savemap,mpt);
		return 0;
	}
	
	InFQPt = 0;
	OutFQPt = -1;

	i = x;
	while (PwGetPoint(mpt,i,y) == seedcolor && 0 <= i){
		i--;
	}
	wleft = i + 1;
	i = x;
	while (PwGetPoint(mpt,i,y) == seedcolor && i < mpt->mapwidth){
		i++;
	}
	wright = i - 1;
	if (_PwPushFQ(FILLDRAW|FILLUP|FILLDOWN,wleft,wright,y) == -1){
		_PwCopyPwgmap(&savemap,mpt);
		return -1;
	}

	while (_PwPopFQ(&dir_flag,&left,&right,&qy) == 0){
		if (PwSignalCode == SIGINT){
			PwSignalCode = 0;
			break;
		}
		if (_PwDrawOver(&savemap,left,right,qy,seedcolor) == -1){
			continue;
		}
		if (dir_flag & FILLDRAW){
			PwDrawLine(mpt,left,qy,right,qy);
		}
		if (dir_flag & FILLUP){
			seed_sw = OFF;
			for (i = left; i <= right; i++){
				color = PwGetPoint(mpt,i,qy - 1);
				if (color == seedcolor && seed_sw == OFF){
					seed_sw = ON;
					wleft = i;
				}
				if (color != seedcolor && seed_sw == ON){
					seed_sw = OFF;
					if (wleft == left){
						j = left;
						while (PwGetPoint(mpt,j,qy - 1) == seedcolor && 0 <= j){
							j--;
						}
						j++;
						if (j < left){
							if (_PwDrawOver(&savemap,j,left-1,qy-1,\
								seedcolor) == 0){
								if (_PwPushFQ(FILLDOWN,j,left-1,qy-1) == -1){
									_PwCopyPwgmap(&savemap,mpt);
									return -1;
								}
							}
							wleft = j;
						}
					}
					if (_PwDrawOver(&savemap,wleft,i-1,qy-1,seedcolor) == 0){
						if (_PwPushFQ(FILLDRAW|FILLUP,wleft,i-1,qy-1) == -1){
							_PwCopyPwgmap(&savemap,mpt);
							return -1;
						}
					}
				}
			}
			if (seed_sw == ON){
				if (wleft == left){
					j = left;
					while (PwGetPoint(mpt,j,qy - 1) == seedcolor && 0 <= j){
						j--;
					}
					j++;
					if (j < left){
						if (_PwDrawOver(&savemap,j,left-1,qy-1,\
							seedcolor) == 0){
							if (_PwPushFQ(FILLDOWN,j,left-1,qy-1) == -1){
								_PwCopyPwgmap(&savemap,mpt);
								return -1;
							}
						}
						wleft = j;
					}
				}
				j = right;
				while (PwGetPoint(mpt,j,qy - 1) == seedcolor && \
						j < mpt->mapwidth){
					j++;
				}
				j--;
				if (right < j){	
					if (_PwDrawOver(&savemap,right+1,j,qy-1,seedcolor) == 0){
						if (_PwPushFQ(FILLDOWN,right + 1,j,qy - 1) == -1){
							_PwCopyPwgmap(&savemap,mpt);
							return -1;
						}
					}
					i = j + 1;
				}
				if (_PwDrawOver(&savemap,wleft,i-1,qy-1,seedcolor) == 0){
					if (_PwPushFQ(FILLDRAW|FILLUP,wleft,i-1,qy-1) == -1){
						_PwCopyPwgmap(&savemap,mpt);
						return -1;
					}
				}
			}
		}
		if (dir_flag & FILLDOWN){
			seed_sw = OFF;
			for (i = left; i <= right; i++){
				color = PwGetPoint(mpt,i,qy + 1);
				if (color == seedcolor && seed_sw == OFF){
					seed_sw = ON;
					wleft = i;
				}
				if (color != seedcolor && seed_sw == ON){
					seed_sw = OFF;
					if (wleft == left){
						j = left;
						while (PwGetPoint(mpt,j,qy + 1) == seedcolor && 0 <= j){
							j--;
						}
						j++;
						if (j < left){
							if (_PwDrawOver(&savemap,j,left-1,qy+1,\
								seedcolor) == 0){
								if (_PwPushFQ(FILLUP,j,left-1,qy+1) == -1){
									_PwCopyPwgmap(&savemap,mpt);
									return -1;
								}
							}
							wleft = j;
						}
					}
					if (_PwDrawOver(&savemap,wleft,i-1,qy+1,seedcolor) == 0){
						if (_PwPushFQ(FILLDRAW|FILLDOWN,wleft,i-1,qy+1) == -1){
							_PwCopyPwgmap(&savemap,mpt);
							return -1;
						}
					}
				}
			}
			if (seed_sw == ON){
				if (wleft == left){
					j = left;
					while (PwGetPoint(mpt,j,qy + 1) == seedcolor && 0 <= j){
						j--;
					}
					j++;
					if (j < left){
						if (_PwDrawOver(&savemap,j,left-1,qy+1,seedcolor) == 0){
							if (_PwPushFQ(FILLUP,j,left-1,qy+1) == -1){
								_PwCopyPwgmap(&savemap,mpt);
								return -1;
							}
						}
						wleft = j;
					}
				}
				j = right;
				while (PwGetPoint(mpt,j,qy + 1) == seedcolor && \
						j < mpt->mapwidth){
					j++;
				}
				j--;
				if (right < j){	
					if (_PwDrawOver(&savemap,right+1,j,qy+1,seedcolor) == 0){
						if (_PwPushFQ(FILLUP,right + 1,j,qy + 1) == -1){
							_PwCopyPwgmap(&savemap,mpt);
							return -1;
						}
					}
					i = j + 1;
				}
				if (_PwDrawOver(&savemap,wleft,i-1,qy+1,seedcolor) == 0){
					if (_PwPushFQ(FILLDRAW|FILLDOWN,wleft,i-1,qy+1) == -1){
						_PwCopyPwgmap(&savemap,mpt);
						return -1;
					}
				}
			}
		}
	}
	_PwCopyPwgmap(&savemap,mpt);
	return 0;
}

int		_PwPushFQ(dir_flag,left,right,y)
int		dir_flag;
int		left;
int		right;
int		y;
{
	FillQue[InFQPt].dir_flag = dir_flag;
	FillQue[InFQPt].left = left;
	FillQue[InFQPt].right = right;
	FillQue[InFQPt].y = y;
	if (OutFQPt == -1){
		OutFQPt = InFQPt;
	}
	InFQPt++;
	if (FILLQUESZ <= InFQPt){
		InFQPt = 0;
	}
	if (InFQPt == OutFQPt){
		return -1;
	}
	return 0;
}

int		_PwPopFQ(dir_flag,left,right,y)
int		*dir_flag;
int		*left;
int		*right;
int		*y;
{
	if (OutFQPt < 0 || OutFQPt == InFQPt){
		return -1;
	}
	*dir_flag = FillQue[OutFQPt].dir_flag;
	*left = FillQue[OutFQPt].left;
	*right = FillQue[OutFQPt].right;
	*y = FillQue[OutFQPt].y;
	OutFQPt++;
	if (FILLQUESZ <= OutFQPt){
		OutFQPt = 0;
	}
	
	return 0;
}

int		_PwDrawOver(mpt,left,right,y,seedcolor)
PWGMAP	*mpt;
int		left;
int		right;
int		y;
int		seedcolor;
{
	unsigned short	map = 0,fg = 0,mask = 0xffff;
	int		len,i;

	len = right - left + 1;
	if (16 < len){
		len = 16;
	}
	mask = mask << (16 - len);
	for (i = 0; i < len; i++){
		map = map << 1;
		map |= PwGetPoint(mpt,left + i,y);
	}
	fg = *((unsigned short *)(mpt->foreground) + (y % 16));
	fg = (fg << (left % 16)) | (fg >> (16 - (left % 16)));

	if ((mpt->drawmode == DM_COPY && seedcolor == 0 && fg == 0) || \
		(mpt->drawmode == DM_COPY && seedcolor == 1 && fg == 0xffff)){
		return 0;
	}
	if ((mpt->drawmode == DM_OR && seedcolor == 0 && fg == 0) || \
		(mpt->drawmode == DM_OR && seedcolor == 1)){
		return 0;
	}
	if ((mpt->drawmode == DM_XOR && seedcolor == 0 && fg == 0) || \
		(mpt->drawmode == DM_XOR && seedcolor == 1 && fg == 0)){
		return 0;
	}
	if ((mpt->drawmode == DM_NOT && seedcolor == 0) || \
		(mpt->drawmode == DM_NOT && seedcolor == 1 && fg == 0)){
		return 0;
	}

	switch (mpt->drawmode){
	case	DM_COPY:	/* == SRC */
		if (((map ^ fg) & mask) == 0){
			return -1;
		}
		break;
	case	DM_OR:
		if (((map ^ fg) & mask) == 0){
			return -1;
		}
		break;
	case	DM_XOR:
		if (seedcolor == 0){
			if (((map ^ fg) & mask) == 0){
				return -1;
			}
		}else{
			if (((map & fg) & mask) == 0){
				return -1;
			}
		}
		break;
	case	DM_NOT:
		if (((map & fg) & mask) == 0){
			return -1;
		}
		break;
	default:
		break;
	}
	return 0;
}

/*
 *	function:	get bit image from bitmap
 *
 *	return:		 0 ... bit is OFF
 *				 1 ... bit is ON
 *				-1 ... wrong paramaters
 *
 */
int		PwGetPoint(mpt,x,y)
PWGMAP	*mpt;	/* input:pointer to PWGMAP */
int		x;		/* relative x on bitmap */
int		y;		/* relative y on bitmap */
{
	unsigned char	*addr,mask;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	if (x < 0 || mpt->mapwidth <= x){
		return -1;
	}
	if (y < 0 || mpt->mapheight <= y){
		return -1;
	}

	addr = (x >> 3) + mpt->maprow * y + mpt->mapaddress;
	mask = 0x80 >> (x & 7);

	return ((*addr & mask) ? 1:0);
}

/*
 *	function:	get image from specified area of personal-window into bitmap
 *
 *	return:		 0 ... normal
 *				-1 ... error
 *
 */
int		PwGetWindowArea(mpt,left,top,width,height)
PWGMAP	*mpt;		/* input:pointer to PWGMAP */
int		left;		/* input:left point of rectangle on bitmap */
int		top;		/* input:top point of rectangle on bitmap */
int		width;		/* input:width of rectangle */
int		height;		/* input:height of rectangle */
{
	int		ret;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}
	
	ret = _pw_imgget(mpt->path,WIN_DEF_ID,mpt->mapaddress,mpt->maprow,left,\
					 top,left + width,top + height);

	return ret;
}

/*
 *	function:	get image from personal-window into bitmap
 *
 *	return:		 0 ... normal
 *				-1 ... error
 *
 */
int		PwGetWindowMap(mpt)
PWGMAP	*mpt;	/* pointer to PWGMAP */
{
	int		ret;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	ret = PwGetWindowArea(mpt,mpt->windowleft,mpt->windowtop, \
						   mpt->windowwidth,mpt->windowheight);
	return ret;
}

/*
 *	function:	get image from memory array into bitmap
 *
 *	return:		 0 ... normal
 *				-1 ... error
 *
 */
int		PwGetBitMap(mpt,bpt,width,height,row)
PWGMAP			*mpt;		/* input:pointer to PWGMAP */
unsigned char	*bpt;		/* input:pointer to bit image char array */
int				width;		/* input:width of bit image (dummy) */
int				height;		/* input:height of bit image */
int				row;		/* input:rowbytes of bit image */
{
	int		i, j, minheight, minrow;
	
	if (mpt == (PWGMAP *)NULL || bpt == (unsigned char *)NULL){
		return -1;
	}
	
	minheight = (height < mpt->mapheight ? height : mpt->mapheight);
	minrow = (row < mpt->maprow ? row : mpt->maprow);
	
	for (i = 0; i < minheight; i++){
		for (j = 0; j < minrow; j++){
			mpt->mapaddress[i * mpt->maprow + j] = bpt[i * row + j];
		}
	}
	return 0;
}

/*
 *	function:	copy image between bitmap
 *
 *	return:		 0 ... normal
 *				-1 ... error
 *
 */
int		PwCopyArea(src_mpt,dst_mpt,src_left,src_top,width,height,dst_left, \
				   dst_top)
PWGMAP	*src_mpt;	/* input:pointer to PWGMAP of source */
PWGMAP	*dst_mpt;	/* input:pointer to PWGMAP of distination */
int		src_left;	/* input:point left of source bitmap */
int		src_top;	/* input:point top of source bitmap */
int		width;		/* input:width of source */
int		height;		/* input:height of source */ 
int		dst_left;	/* input:point left of distination bitmap */
int		dst_top;	/* input:point top of distination bitmap */
{
	int		src_y,dst_y,dy,src_right,dst_right,cnty,src_leftrow,src_rightrow;
	int		rowwidth,src_left_mod_8,src_right_mod_8,dst_left_mod_8;
	int		dst_right_mod_8,dif_mod_8,rev_mod_8,notlr,notrr,i,dst_leftrow;
	int		dst_rightrow;
	unsigned char	*pt,*pts,*pte;
	unsigned char	buf[129];
	
	if (src_mpt == (PWGMAP *)NULL || dst_mpt == (PWGMAP *)NULL){
		return -1;
	}
	
	if (dst_mpt->mapwidth < dst_left + width ||
		dst_mpt->mapheight < dst_top + height ||
		dst_left < 0 || dst_top < 0){
		return -1;
	}

	src_right = src_left + width;
	dst_right = dst_left + width;

	if (src_top <= dst_top){
		src_y = src_top + height - 1;
		dst_y = dst_top + height - 1;
		dy = -1;
	}else{
		src_y = src_top;
		dst_y = dst_top;
		dy = 1;
	}

	src_leftrow = src_left >> 3;
	src_rightrow = src_right >> 3;
	rowwidth = src_rightrow - src_leftrow;
	dst_leftrow = dst_left >> 3;
	dst_rightrow = dst_right >> 3;

	src_left_mod_8 = src_left & 7;
	src_right_mod_8 = src_right & 7;
	dst_left_mod_8 = dst_left & 7;
	dst_right_mod_8 = dst_right & 7;
	if (src_left_mod_8 < dst_left_mod_8){
		dif_mod_8 = dst_left_mod_8 - src_left_mod_8;
	}else{
		dif_mod_8 = src_left_mod_8 - dst_left_mod_8;
	}
	rev_mod_8 = 8 - dif_mod_8;

	notlr = ~lrmask[dst_left_mod_8];
	notrr = ~rrmask[dst_right_mod_8];

	cnty = height;		
	while (cnty--){
		pts = (unsigned char *)src_mpt->mapaddress + src_mpt->maprow * src_y + \
				src_leftrow;
		pte = (unsigned char *)src_mpt->mapaddress + src_mpt->maprow * src_y + \
				src_rightrow;
		for (pt = pts, i = 0; pt <= pte; pt++, i++){
			buf[i] = *pt;
			if (pt == pts){
				buf[i] &= lrmask[src_left_mod_8];
			}
			if (pt == pte){
				buf[i] &= rrmask[src_right_mod_8];
			}
		}
		buf[i] = 0;
			
		if (src_left_mod_8 < dst_left_mod_8){
			for (i = rowwidth; 0 <= i; i--){
				buf[i + 1] |= (buf[i] << rev_mod_8);
				buf[i] = buf[i] >> dif_mod_8;
			}
		}else if (dst_left_mod_8 < src_left_mod_8){
			for (i = 0; i <= rowwidth; i++){
				if (0 < i){
					buf[i - 1] |= (buf[i] >> rev_mod_8);
				}
				buf[i] = buf[i] << dif_mod_8;
			}
		}

		pts = (unsigned char *)dst_mpt->mapaddress + dst_mpt->maprow * dst_y + \
				dst_leftrow;
		pte = (unsigned char *)dst_mpt->mapaddress + dst_mpt->maprow * dst_y + \
				dst_rightrow;

		for (pt = pts, i = 0; pt <= pte; pt++, i++){
			switch (dst_mpt->drawmode){
			case DM_NOT:
				*pt = *pt & ~buf[i];
				break;
			case DM_OR:
				*pt = *pt | buf[i];
				break;
			case DM_XOR:
				*pt = *pt ^ buf[i];
				break;
			case DM_COPY:
			default:
				if (pt == pts && pt == pte){
					*pt = *pt & (notlr | notrr) | buf[i];
				}else if (pt == pts){
					*pt = *pt & notlr | buf[i];
				}else if (pt == pte){
					*pt = *pt & notrr | buf[i];
				}else{
					*pt = buf[i];
				}
				break;
			}
		}
		src_y += dy;
		dst_y += dy;
	}

	if (dst_mpt->flushmode != FLS_NONE){
		PwFlushArea(dst_mpt,dst_left,dst_top,width,height, \
					dst_mpt->flushmode);
	}
	return 0;
}

/*
 *	function:	sub function(copy PWGMAP)
 *
 *	return:		0  ... normal
 *				-1 ... error
 */
int		_PwCopyPwgmap(src_mpt,dst_mpt)
PWGMAP	*src_mpt;	/* poionter to source PWGMAP */
PWGMAP	*dst_mpt;	/* pointter to distination PWGMAP */
{
	int		i;
	
	if (src_mpt == (PWGMAP *)NULL || dst_mpt == (PWGMAP *)NULL){
		return -1;
	}

	for (i = 0;i < sizeof (PWGMAP);i++){
		*(((unsigned char *)dst_mpt)++) = *(((unsigned char *)src_mpt)++);
	}
	return 0;
}

/*
 *	function:	flush specified bitmap area on personal-window
 *
 *	return:		 0 ... normal
 *				-1 ... error
 */
int		PwFlushArea(mpt,left,top,width,height,flushmode)
PWGMAP	*mpt;		/* pointer to PWGMAP */
int		left;		/* flush left point on bitmap */
int		top;		/* flush top point on bitmap */
int		width;		/* flush width */
int		height;		/* flush height */
int		flushmode;	/* flush mode(FLS_NORMAL,FLS_REVERSE,FLS_NONE) */
{
	int		wleft,wtop,wright,wbottom;
	unsigned char	*addr;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	if (flushmode == FLS_NONE){
		return 0;
	}
	if (mpt->mapwidth <= left){
		return -1;
	}
	if (mpt->mapheight <= top){
		return -1;
	}
	if ((left + width) <= 0){
		return -1;
	}
	if ((top + height) <= 0){
		return -1;
	}

	if (left < 0){
		width += left;
		left = 0;
	}
	if (top < 0){
		height += top;
		top = 0;
	}
	if (mpt->mapwidth < (left + width)){
		width = mpt->mapwidth - left;
	}
	if (mpt->mapheight < (top + height)){
		height = mpt->mapheight - top;
	}

/* _pw_imgput  addr ̓[hEłȂƂȂH */
	addr = (mpt->mapaddress) + (mpt->maprow) * top + (left / 16) * 2;

	wleft = mpt->windowleft + (left & (~15));

	wtop = mpt->windowtop + top;

/* wright - wleft  PU̔{łȂƂȂH */
	if ((((left + width) & (~15)) + 16) <= mpt->windowwidth){
		wright = mpt->windowleft + ((left + width) & (~15)) + 16;
	}else{
/* ̏ꍇ͓삪 (^^;) */
		wright = mpt->windowleft + mpt->windowwidth;
	}

	wbottom = mpt->windowtop + top + height;

	_pw_imgput(mpt->path,WIN_DEF_ID,addr,mpt->maprow,wleft,wtop,wright,wbottom);

	wleft = mpt->windowleft + left;
	wright = mpt->windowleft + left + width;
	_pw_flush(mpt->path,WIN_DEF_ID,wleft,wtop,wright,wbottom,flushmode);

	return 0;
}

/*
 *	function:	flush bitmap area on personal-window
 *
 *	return:		 0 ... normal
 *				-1 ... error
 */
int		PwFlushMap(mpt,flushmode)
PWGMAP	*mpt;		/* pointer to PWGMAP */
int		flushmode;	/* flush mode(FLS_NORMAL,FLS_REVERSE,FLS_NONE) */
{
	int		ret;
	
	if (mpt == (PWGMAP *)NULL){
		return -1;
	}

	ret = PwFlushArea(mpt,0,0,mpt->windowwidth,mpt->windowheight,flushmode);
	return ret;
}
